﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
// Added for Azure Table Storage Services
using Microsoft.Samples.ServiceHosting.StorageClient;
using System.Data.Services.Client;


namespace SampleWebCloudService_WebRole
{
    #region CustomerDataModel class generated by LIMOG v2
    public class CustomerDataModel : TableStorageEntity
    {
        // Default parameterless constructor
        public CustomerDataModel()
            : base()
        {
            RowKey = Guid.NewGuid().ToString();
            PartitionKey = "CustomerDataModel";
        }
        // Partial parameterized constructor
        public CustomerDataModel(string partitionKey, string rowKey)
            : base(partitionKey, rowKey)
        {
        }

        public string CustomerID { get; set; }
        public string CompanyName { get; set; }
        public string ContactName { get; set; }
        public string ContactTitle { get; set; }
        public string Address { get; set; }
        public string City { get; set; }
        public string Region { get; set; }
        public string PostalCode { get; set; }
        public string Country { get; set; }
        public string Phone { get; set; }
        public string Fax { get; set; }
    }
    #endregion

    #region OrderDataModel class generated by LIMOG v2
    public class OrderDataModel : TableStorageEntity
    {
        // Default parameterless constructor
        public OrderDataModel()
             : base()
        {
            RowKey = Guid.NewGuid().ToString();
            PartitionKey = "OrderDataModel";
        }
        // Partial parameterized constructor
        public OrderDataModel(string partitionKey, string rowKey)
            : base(partitionKey, rowKey)
        {
        }

        public int OrderID { get; set; }
        public string CustomerID { get; set; }
        public int EmployeeID { get; set; }
        public DateTime OrderDate { get; set; }
        public DateTime RequiredDate { get; set; }
        public DateTime ShippedDate { get; set; }
        public int ShipVia { get; set; }
        public double Freight { get; set; }
        public string ShipName { get; set; }
        public string ShipAddress { get; set; }
        public string ShipCity { get; set; }
        public string ShipRegion { get; set; }
        public string ShipPostalCode { get; set; }
        public string ShipCountry { get; set; }
    }
    #endregion

    #region EmployeeDataModel class generated by the LINQ In-Memory Object Generator (LIMOG) v2
    public class EmployeeDataModel : TableStorageEntity
    {
        // Default parameterless constructor
        public EmployeeDataModel()
            : base()
        {
            RowKey = Guid.NewGuid().ToString();
            PartitionKey = "EmployeeDataModel";
        }
        // Partial parameterized constructor
        public EmployeeDataModel(string partitionKey, string rowKey)
            : base(partitionKey, rowKey)
        {
        }

        public int EmployeeID { get; set; }
        public string LastName { get; set; }
        public string FirstName { get; set; }
        public string Title { get; set; }
        public string TitleOfCourtesy { get; set; }
        public DateTime BirthDate { get; set; }
        public DateTime HireDate { get; set; }
        public string Address { get; set; }
        public string City { get; set; }
        public string Region { get; set; }
        public string PostalCode { get; set; }
        public string Country { get; set; }
        public string HomePhone { get; set; }
        public string Extension { get; set; }
        public string Notes { get; set; }
        public int ReportsTo { get; set; }
        public string PhotoPath { get; set; }
    }
    #endregion

    // Test for GUID type
    #region SalesOrderDetailDataModel class generated by the LINQ In-Memory Object Generator (LIMOG) v2
    public class SalesOrderDetailDataModel : TableStorageEntity
    {
        // Default parameterless constructor
        public SalesOrderDetailDataModel()
            : base()
        {
            RowKey = Guid.NewGuid().ToString();
            PartitionKey = "SalesOrderDetailDataModel";
        }
        // Partial parameterized constructor
        public SalesOrderDetailDataModel(string partitionKey, string rowKey)
            : base(partitionKey, rowKey)
        {
        }

        public int SalesOrderID { get; set; }
        public int SalesOrderDetailID { get; set; }
        public string CarrierTrackingNumber { get; set; }
        public int OrderQty { get; set; }
        public int ProductID { get; set; }
        public int SpecialOfferID { get; set; }
        public double UnitPrice { get; set; }
        public double UnitPriceDiscount { get; set; }
        public double LineTotal { get; set; }
        public Guid rowguid { get; set; }
        public DateTime ModifiedDate { get; set; }
    }
    #endregion


    #region EntityNameDataServiceContext (implementing IQueryable generates table)
    internal class CustomerDataServiceContext : TableStorageDataServiceContext
    {
        internal CustomerDataServiceContext(StorageAccountInfo accountInfo)
            : base(accountInfo)
        {
        }

        internal const string CustomerTableName = "CustomerTable";

        public IQueryable<CustomerDataModel> CustomerTable
        {
            get
            {
                return this.CreateQuery<CustomerDataModel>(CustomerTableName);
            }
        }

        public class CustomerDataSource
        {
            private CustomerDataServiceContext serviceContext = null;

            public CustomerDataSource()
            {
                // Get the settings from the Service Configuration file
                StorageAccountInfo account = 
                    StorageAccountInfo.GetDefaultTableStorageAccountFromConfiguration();

                // Create tables for public properties that implement IQueryable
                TableStorage.CreateTablesFromModel(typeof(CustomerDataServiceContext), 
                    account);

                // Create the service context to query against
                serviceContext = new CustomerDataServiceContext(account);
                serviceContext.RetryPolicy = 
                    RetryPolicies.RetryN(3, TimeSpan.FromSeconds(1));
            }

            public IEnumerable<CustomerDataModel> Select()
            {
                // Page.Prerender event-handler populates GridView
                // Function is required for ObjectDataSource
                return null;
            }
            
            public void Delete(CustomerDataModel itemToDelete)
            {
                serviceContext.AttachTo(CustomerDataServiceContext.
                    CustomerTableName, itemToDelete, "*");
                serviceContext.DeleteObject(itemToDelete);
                serviceContext.SaveChanges();
            }

            public void Insert(CustomerDataModel newItem)
            {
                serviceContext.AddObject(CustomerDataServiceContext.
                    CustomerTableName, newItem);
                serviceContext.SaveChanges();
            }
        }
    }
    #endregion
}
