﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
// Added
using Microsoft.Samples.ServiceHosting.StorageClient;

namespace SampleWebCloudService_WebRole
{
    public class Global : System.Web.HttpApplication
    {
        // See: IIS7 Integrated mode: Request is not available in this 
        // context exception in Application_Start
        // by Mike Volodarsky (http://mvolo.com/blogs/serverside/archive/2007/11/10/Integrated-mode-Request-is-not-available-in-this-context-in-Application_5F00_Start.aspx)
        void Application_BeginRequest(object sender, EventArgs e)
        {
            HttpApplication app = (HttpApplication)sender;
            HttpContext context = app.Context;

            // Attempt to perform first request initialization
            FirstRequestInitialization.Initialize(context);
        }

        class FirstRequestInitialization
        {
            private static bool s_InitializedAlready = false;
            private static Object s_lock = new Object();

            // Initialize only on the first request
            public static void Initialize(HttpContext context)
            {
                if (s_InitializedAlready)
                {
                    return;
                }

                lock (s_lock)
                {
                    if (s_InitializedAlready)
                    {
                        return;
                    }

                    ApplicationStartUponFirstRequest(context);
                    s_InitializedAlready = true;
                }
            }
        }

        // See: Try to Create Tables Only Once by Steve Marx 
        // (http://blog.smarx.com/posts/try-to-create-tables-only-once)
        // The Personal WebSite Sample 
        // (http://msdn.microsoft.com/en-us/library/dd135735.aspx) 
        // uses this method to set up users and roles, but not create tables if necessary
        private static void ApplicationStartUponFirstRequest(HttpContext context)
        {
            // Make sure the tables exist before we use them. 
            // (Steve Marx says "This is inefficient but reliable.")
            StorageAccountInfo account = 
                StorageAccountInfo.GetDefaultTableStorageAccountFromConfiguration();
            TableStorage.CreateTablesFromModel(typeof(CustomerDataServiceContext), 
                account);
        }
    }
}